//
//	Copyright 1993, Scott Anguish
//	Basically, you can use it, and improve it, but you can't sell it
//	or include it in a commercial product OR CD-COLLECTION without written permission
//	I'm sure we can work that out though.....

#import <appkit/appkit.h>

@interface ClockView:View
{
    id	theImage;
	id	clockbase;
	
	NXImage *imageA;
	NXImage *imageP;

	NXImage *imageColon;
	NXImage *imageAM;
	NXImage *imagePM;

	NXImage *DigitalNumbers[10];
	NXImage *DateNumbers[10]; 
	NXImage *DayNames[7];
	NXImage *MonthNames[12];
    NXPoint	colonPosition;
	
	int seconds;
	int minutes;
	int hours;
	int date;
	int month;
	int year;
	int weekday;
	int meridian;


}

- initFrame:(const NXRect *)frameRect;
- awake;
- awakeFromNib;
- setTime: (struct tm*)theTime;

- takeMinutesFrom:sender;
- takeHoursFrom:sender;
- takeWeekdayFrom:sender;
- takeDateFrom:sender;
- takeMonthFrom:sender;

- setSeconds:(int)theSeconds;
- setMinutes:(int)theMinutes;
- setHours:(int)theHours;
- setWeekday:(int)theWeekday;
- setDate:(int)theDate;
- setMonth:(int)theMonth;
- setYear:(int)theYear;
- setMeridian:(int)theMeridian;

- (int)year;
- (int)month;
- (int)weekday;
- (int)date;
- (int)hours;
- (int)minutes;
- (int)seconds;

@end
